<?php // "name":"Git plugin for SparkPlug", "author":"Noccy"

namespace SparkPlug\Com\Noccy\Git;

use Spark\Commands\Command;
use SparkPlug;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;

class GitPlug extends SparkPlug
{
    public function load()
    {
        $root = $this->getProjectDirectory();
        if (!file_exists($root."/.git")) {
            return;
        }
        
        register_command(new GitIgnoreCommand());
    }

    public function getIgnoreList(bool $local=false)
    {
        $root = get_environment()->getProjectDirectory();
        $file = $root . (!$local ? "/.gitignore" : "/.git/info/exclude");
        return new IgnoreList($file);
    }
}

//if (file_exists(get_environment()->getConfigDirectory()."/maker.json")) {
register_plugin("com.noccy.git", new GitPlug());
require_once(__DIR__."/helpers.php");
//}
